﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace ConsoleApplication1
{
    class Bullet
    {
        private Point point;  //坐标位置
        private Direction direction=new Direction (); //方向，水平方向，垂直方向
        private static EnemyTank etank = new EnemyTank();
        

        public Direction Direction
        {
            get { return direction; }
            set { direction = value; }
        }

        public Point Point
        {
            get { return point; }
            set { point = value; }
        }

        /// <summary>
        /// 移动子弹
        /// </summary>
        public bool Move()
        {
            int x = 1;
            int y = 1;
            Point p = new Point(point.X, point.Y, true);
            etank.Point = p;
            Direction d = new Direction(direction.LevelState);
            etank.Direction = d;
          

            if (!Collide(direction.LevelState)||!etank.BulletCollide() )  //判断子弹是否碰撞边框或者敌方坦克
                return false;

         
            if (direction.LevelState == MoveType.Left)
            {
                x = point.X - 1;
                y = point.Y;
            }
            else if (direction.LevelState == MoveType.Right)
            {
                x = point.X + 1;
                y = point.Y;
            }
            else if (direction.LevelState == MoveType.Up)
            {
                x = point.X ;
                y = point.Y-1;
            }
            else if (direction.LevelState == MoveType.Down)
            {
                x = point.X;
                y = point.Y+1;
            }
            if (!point.IsFirst)
            {
                Clear(); 
            }
             
            point.X = x;
            point.Y = y;
            point.IsFirst = false;
           

            if (point.X > 0 && point.X <= From.Width && point.Y > 0 && point.Y <= From.Height)
            {
                Console.ForegroundColor = ConsoleColor.Red;
                From.Map[x-1, y-1] = 1;
                Console.SetCursorPosition(x * 2, y);
                Console.Write("☉");

            }
            else  //子弹碰撞到边框后触发器暂停0.2秒
            {
                System.Threading.Thread.Sleep(200);
            }
            return true;
        }

        /// <summary>
        /// 判断子弹是否碰到边框
        /// </summary>
        /// <param name="type"></param>
        /// <returns></returns>
        public bool Collide(MoveType type)
        {
            bool tan = true;

            //左
            if (type == MoveType.Left)
            {
                if (point.X > 0)
                {
                }
                else
                {
                    tan = false;
                }
            }


            if (type == MoveType.Right)
            {
                if (point.X <= From.Width)
                {
               
                }
                else
                {
                    tan = false;
                }
            }

            if (type == MoveType.Up)
            {
                if (point.Y > 0)
                {

                }
                else
                {
                    tan = false;
                }
            }

            if (type == MoveType.Down)
            {
                if (point.Y <= From.Height)
                {

                }
                else
                {
                    tan = false;
                }
            }
           
            return tan;
        }

        /// <summary>
        /// 清除小球走过的路经 
        /// </summary>
        public virtual void Clear()
        {
            Clear(point.X, point.Y);
        }

        /// <summary>
        /// 清除子弹运行后轨迹
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public void Clear(int x, int y)
        {
            Console.SetCursorPosition(x*2, y);
            Console.Write(" ");
            From.Map[x-1, y-1] = 0;
        }
    }
}
