﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;

namespace ConsoleApplication1
{
    public class Game
    {
        private static bool isMortality = false; //判断是否死亡
        private Tank tank; //坦克
        private EnemyTank etank;  //敌方坦克
        private static bool isWin = false; //判断是否赢了


     
        public static bool IsWin
        {
            get { return isWin; }
            set { isWin = value; }
        }

        public static bool IsMortality1
        {
            get { return Game.isMortality; }
            set { Game.isMortality = value; }
        }


        public Game()
        {

            From f = new From();
            f.DrawBorder();  //绘制边框

            tank = new Tank();
            tank.Draw(MoveType.Right);  //绘制坦克

            etank = new EnemyTank();
            etank.Draw(MoveType.Down);   //绘制敌方坦克
           

            Run();   //运行

            //其实坦克就是这样绘制出来的，
            //Console.WriteLine("▓▓▓");
            //Console.WriteLine("  ◆―");
            //Console.WriteLine("▓▓▓");

            Console.Read();
        }

        //运行
        private void Run()
        {
            etank.BallMoveEvent();  //创建敌方坦克移动使用的触发器
            while (!isMortality && !isWin)
            {

                if (!tank.StartInput() && !isWin)
                {
                    tank.BallMoveEvent();  //创建子弹移动使用的触发器
                }

            }
        }
    }
}
